

class multisection : public object {
   ;
	public:
   int thresh;
   list<object*>objs;
   void findintersect(const Vector& from,const Vector& dir,float mindist,intersect &best) {
      intersect t;
      object *o=NULL;
      best.dist = FLT_MAX;
      best.p = NULL;
      for (list<object *>::iterator li = objs.begin();li != objs.end();li++) {
	 (*li)->findintersect(from,dir,mindist,t);
	 if (!t.p || t.dist < mindist) continue;
	 if (t.dist<best.dist) {
	    best = t;
	    o = *li;
	 }
      }
      if(!best.p) return;
      int count =1;
      if(count >=thresh) return;
      for (list<object *>::iterator li = objs.begin();li != objs.end();li++) {
	 if(*li==o) continue;
	 if((*li)->isinside(from+(dir*best.dist))) count++;
	 if(count >=thresh) return;
      }
      this->findintersect(from,dir,best.dist+.01,best);
   }
   bool isinside(const Vector &p) {
      int count=0;
      for (list<object *>::iterator li = objs.begin();li != objs.end();li++) {
	 if((*li)->isinside(p)) count++;
	 if(count >= thresh) return true;
      }
      return false;
   }
   void post_process() {
      for (list<object *>::iterator li = objs.begin();li != objs.end();li++) 
	 (*li)->post_process();
   }
   void print(ostream &os) const {
      os << "multisection " << thresh << endl;
      os << "<<begin>>\n";
      for (list<object *>::const_iterator li = objs.begin();li != objs.end();li++) 
	 (*li)->print(os);
      os << "<<end>>\n";
   }

};
