%{

#include<math.h>
#include "engine.h"
#include "multisection.h"
#include "primitive.h"
#include "rtparse.tab.cc.h"
#include <unistd.h>

int find_tokenstring(char *s);


%}

DIGIT [0-9]
ID [a-zA-Z][_a-zA-Z0-9]*


%x LAMP
 

%%

"/*".*"*/" 

"//".*$   

{DIGIT}*"."?{DIGIT}+|({DIGIT}+"."?{DIGIT}*)	{ 
			yylval.flt = atof(yytext); 
			return NUM;
			}
{ID}		{
		int i;
		if((i=find_tokenstring(yytext))) {
		   //fprintf(stderr, "Recognized id! %s %i\n",yytext,i);
		   return i;
		}
		   fprintf(stderr, "Unrecognized id: %s \n",yytext);
 		   exit(1);
		}

[()+-/*,]	{
		return yytext[0];
		}


[ \t\n,]+	{}

.	{fprintf(stderr, "Unrecognized character: %s \n",yytext);
		exit(1);
		}
%%

