
false = 0
true = 1

class vector:
	def __init__(self,i=0.0,j=0.0,k=0.0):
		self.i=float(i)
		self.j=float(j)
		self.k=float(k)
	#def __init__(self,v):
	#	self.i=v.i
	#	self.j=v.j
	#	self.k=v.k
	def __add__(s,o):
		return vector(s.i+o.i,s.j+o.j,s.k+o.k)
	def __repr__(self):
		return `self.i` + " " + `self.j` + " " + `self.k`

color=vector

class material:
	luminant = false
	luminance = color()
	present = true
	diffuse = color()
	specular = color()
	reflective = color()
	def __init__(self,o=None):
		if o:
			self.luminant = o.luminant
			self.luminance = o.luminance
			self.present = o.present
			self.diffuse = o.diffuse
			self.specular = o.specular
			self.reflective = o.reflective
	def output(self):
		if(self.luminant): print "lamp"; print "transparent"
		print "diffuse " + `self.diffuse`
		print "specular " + `self.specular`
		print "reflective " + `self.reflective`
		print "luminance " + `self.luminance`
		
		
class object: 
	def __init__(self,location = vector(),att=None):
		self.att=att
		self.location = location;
	def output(self):
		print "location " + `self.location`
		if(self.att): self.att.output()
		
	
class sphere(object):
	def __init__(self,location = vector(),att=None,radius=1.0):	
		object.__init__(self,location,att)
		self.radius = radius
	def output(self):
		print "sphere"
		object.output(self)
		print "radius " + `self.radius`

class plane(object):
	def __init__(self,location=vector(),att=None,normal=vector(0,1,0)):	
		object.__init__(self,location,att)
		self.normal = normal
	def output(self):
		print "plane"
		object.output(self)
		print "normal " + `self.normal`
		

class union(object):
	def __init__(self,location=vector(),att=None,obs=[]):
		object.__init__(self,location,att)
		self.objects = obs;
	def append(self,what):
		self.objects.append(what)
	def output(self): 
		print "multisection  1"
		for a in self.objects:
			if (a.att==None): a.att = self.att
			a.output()
		print "endmultisection"
		
filename="rt.out"
yres=256
xres=256
ambient = color()
camera = vector()
zoom = 1.0
universe = union(att = material())

def trace(): 
	print "ambient " + `ambient`
	print "camera " + `camera`
	print "zoom " + `zoom`
	universe.output()
